/* yasep/JScore/yasep_fields.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
2007-04-16 by whygee@f-cpu.org
2007-11-05 : rebranding to YASEP
2009-05-26 : changed / updated some fields
2009-07-15 : update, new extended fields
2009-07-28 : added Y
2009-08-15 : added Y.FIELD_EXTIMM4 (renamed to FIELD_AUX 2014-02-06)
2009-08-16 : added Y.FIELD_EXTxxx
2009-08-23 : exchanged again EXTDST3 & EXTSRC4
2014-02-06 : new ISA, big changes

   See #!doc/forms

   Dependency : yasep_forms.js
*/

F2=0xFF;
F4=0xFFFF;
F8=0xFFFFFFFF;

Y.FIELD_IMMREG   =          1; // LSB : short/long flag
Y.FIELD_EXTFORM  =          2; // imm4 or extended ?
Y.FIELD_GROUP    =       0x1C; // 8 groups
Y.FIELD_FUNCTION =       0xE0; // 8 functions
Y.FIELD_OPCODE   =       0xFC;
Y.FIELD_SND      =      0xF00;
Y.FIELD_SI4      =     0xF000;
Y.FIELD_IMM6     =    0x3F000;
Y.FIELD_IMM16    =    F4<<12 ; // 0x0FFFF000;
Y.FIELD_UPD2     = 0x000C0000; // unused yet
Y.FIELD_UPD4     = 0x000F0000; // unused yet
Y.FIELD_AUX      = 0x00100000; // imm6/reg ? (ex-EXTIMM4)
Y.FIELD_CNDCODE  = 0x00E00000; // 3 bits, among them :
Y.FIELD_CNDNEG   = 0x00200000; //   negation of the condition
Y.FIELD_CNDBIT   = 0x00800000; //   =1 for LSB/MSB
Y.FIELD_CND      = 0x0F000000; // 
Y.FIELD_DST      = 0xF0000000; // destination register in long instructions

Y.OFFSET_SND     = 8;
Y.OFFSET_SI4     = 12;
Y.OFFSET_CNDCODE = 21;
Y.OFFSET_CND     = 24;
Y.OFFSET_DST     = 28;
