/* DeforaOS/Apps/Devel/src/asm/test/yasep.S
   Copyright (c) 2011 Pierre Pronchery <khorben@defora.org>
   Copyright (c) 2011-2012 Yann Guidon <whygee@f-cpu.org>
   This file is part of DeforaOS Devel asm

   Assembly language dump to test the Defora
    assembler for the YASEP architecture.
   Bytes are in little endian order.


   Généré le Wed, 31 Jul 2013 04:16:36 GMT
   par http://127.0.0.1/
      yasep/defora/gen_asm.js version 2013/07/31
 */

.text
/* 0x14 = ADD : Addition*/
	add a5 pc               /* FORM_RR     0x14 0x70               */
	add a5 pc never         /* FORM_RR     0x17 0x70 0x20 0x00     */
	add 2 a5                /* FORM_iR     0x16 0x27               */
	add 2 a5 msb0 a5        /* FORM_iR     0x17 0x27 0xE2 0x77     */
	add 11809 d2 d3         /* FORM_IRR    0x15 0xAC 0x21 0x2E     */
	add 22201 r2            /* FORM_IR     0x15 0x22 0xB9 0x56     */
	add r1 r4 pc            /* FORM_RRR    0x17 0x14 0x00 0x00     */
	add r1 r4 pc carry      /* FORM_RRR    0x17 0x14 0x80 0x00     */
	add 4 a3 r1             /* FORM_iRR    0x17 0x4B 0x02 0x01     */
	add 4 a3 r1 lsb1 d3     /* FORM_iRR    0x17 0x4B 0x82 0xA1     */

/* 0x10 = AND : Boolean AND*/
	and d1 a4               /* FORM_RR     0x10 0xE9               */
	and d1 a4 no_carry      /* FORM_RR     0x13 0xE9 0xA0 0x09     */
	and 5 d2                /* FORM_iR     0x12 0x5C               */
	and 5 d2 carry          /* FORM_iR     0x13 0x5C 0x82 0x0C     */
	and 13955 a2 r5         /* FORM_IRR    0x11 0x5D 0x83 0x36     */
	and 22484 r5            /* FORM_IR     0x11 0x55 0xD4 0x57     */
	and d3 r2 r1            /* FORM_RRR    0x13 0xA2 0x00 0x01     */
	and d3 r2 r1 nz r3      /* FORM_RRR    0x13 0xA2 0x20 0x31     */
	and 7 r3 r4             /* FORM_iRR    0x13 0x73 0x02 0x04     */
	and 7 r3 r4 bit1 6      /* FORM_iRR    0x13 0x73 0x42 0x64     */

/* 0x30 = ANDN : Boolean AND with one negated input*/
	andn a2 r2              /* FORM_RR     0x30 0xD2               */
	andn a2 r2 carry        /* FORM_RR     0x33 0xD2 0x80 0x02     */
	andn 7 a2               /* FORM_iR     0x32 0x7D               */
	andn 7 a2 never         /* FORM_iR     0x33 0x7D 0x22 0x0D     */
	andn 13686 a4 r5        /* FORM_IRR    0x31 0x59 0x76 0x35     */
	andn 31079 a4           /* FORM_IR     0x31 0x99 0x67 0x79     */
	andn d3 r3 d2           /* FORM_RRR    0x33 0xA3 0x00 0x0C     */
	andn d3 r3 d2 no_carry  /* FORM_RRR    0x33 0xA3 0xA0 0x0C     */
	andn 7 d2 r1            /* FORM_iRR    0x33 0x7C 0x02 0x01     */
	andn 7 d2 r1 neq        /* FORM_iRR    0x33 0x7C 0xE2 0x01     */

/* 0xC0 = CALL : Jump to SI4/IMM16/IMM20 (R/I/i) and write the NPC to SND*/
	call r3 r5              /* FORM_RR     0xC0 0x35               */
	call r3 r5 zero d1      /* FORM_RR     0xC3 0x35 0x00 0xE5     */
	call 1 d5               /* FORM_iR     0xC2 0x16               */
	call 1 d5 never         /* FORM_iR     0xC3 0x16 0x22 0x06     */
	call 468570 a5          /* FORM_IR     0xC1 0x77 0x5A 0x26     */

/* 0xE0 = CALL2 : Jump to SND+(SI4/IMM16) and write the NPC to SND/DST3*/
	call2 4033 r1 r3        /* FORM_IRR    0xE1 0x31 0xC1 0x0F     */
	call2 d3 r5 d2          /* FORM_RRR    0xE3 0xA5 0x00 0x0C     */
	call2 d3 r5 d2 neq      /* FORM_RRR    0xE3 0xA5 0xE0 0x0C     */
	call2 2 d4 d2           /* FORM_iRR    0xE3 0x28 0x02 0x0C     */
	call2 2 d4 d2 bit0 4    /* FORM_iRR    0xE3 0x28 0x62 0x4C     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x54 = CMPE (alias to CMPU) : CoMPare for Equality*/
	cmpe d3 r5              /* FORM_RR     0x54 0xA5               */
	cmpe d3 r5 nz r4        /* FORM_RR     0x57 0xA5 0x20 0x45     */
	cmpe 5 r4               /* FORM_iR     0x56 0x54               */
	cmpe 5 r4 eq            /* FORM_iR     0x57 0x54 0xC2 0x04     */
	cmpe 25712 a5           /* FORM_IR     0x55 0x07 0x70 0x64     */
#endif

/* 0x74 = CMPS : signed substract the 2 operands and set the Carry bit if borrow*/
	cmps a5 d2              /* FORM_RR     0x74 0x7C               */
	cmps a5 d2 never        /* FORM_RR     0x77 0x7C 0x20 0x0C     */
	cmps 6 a4               /* FORM_iR     0x76 0x69               */
	cmps 6 a4 carry         /* FORM_iR     0x77 0x69 0x82 0x09     */
	cmps 16130 a5           /* FORM_IR     0x75 0x07 0x02 0x3F     */

/* 0x54 = CMPU : unsigned substract the 2 operands and set the Carry bit if borrow*/
	cmpu a3 d3              /* FORM_RR     0x54 0xBA               */
	cmpu a3 d3 neq          /* FORM_RR     0x57 0xBA 0xE0 0x0A     */
	cmpu 3 d3               /* FORM_iR     0x56 0x3A               */
	cmpu 3 d3 nz r1         /* FORM_iR     0x57 0x3A 0x22 0x1A     */
	cmpu 23480 d4           /* FORM_IR     0x55 0x08 0xB8 0x5B     */

/* 0x20 = CRIT : Start a CRITical section: disable IRQs for imm4 instructions*/
	crit 4                  /* FORM_i      0x22 0x40               */

/* 0x68 = ESB : Extract and Sign-extend Byte*/
	esb a2 r5 r3            /* FORM_RRR    0x6B 0xD5 0x00 0x03     */
	esb a2 r5 r3 no_carry   /* FORM_RRR    0x6B 0xD5 0xA0 0x03     */
	esb 3 r1 d2             /* FORM_iRR    0x6B 0x31 0x02 0x0C     */
	esb 3 r1 d2 lsb0 d2     /* FORM_iRR    0x6B 0x31 0xA2 0xCC     */

#if defined(ARCH_yasep32)
/* 0xE8 = ESH : Extract and Sign-extend Half-word*/
	esh d1 r4 a4            /* FORM_RRR    0xEB 0xE4 0x00 0x09     */
	esh d1 r4 a4 bit1 5     /* FORM_RRR    0xEB 0xE4 0x40 0x59     */
	esh 3 a5 r1             /* FORM_iRR    0xEB 0x37 0x02 0x01     */
	esh 3 a5 r1 zero a3     /* FORM_iRR    0xEB 0x37 0x02 0xB1     */
#endif

/* 0x48 = EZB : Extract and Zero-extend Byte*/
	ezb a3 pc a5            /* FORM_RRR    0x4B 0xB0 0x00 0x07     */
	ezb a3 pc a5 lsb0 r1    /* FORM_RRR    0x4B 0xB0 0xA0 0x17     */
	ezb 2 r3 d1             /* FORM_iRR    0x4B 0x23 0x02 0x0E     */
	ezb 2 r3 d1 no_carry    /* FORM_iRR    0x4B 0x23 0xA2 0x0E     */

#if defined(ARCH_yasep32)
/* 0xC8 = EZH : Extract and Zero-extend Half-word*/
	ezh d5 r4 r1            /* FORM_RRR    0xCB 0x64 0x00 0x01     */
	ezh d5 r4 r1 lsb0 d1    /* FORM_RRR    0xCB 0x64 0xA0 0xE1     */
	ezh 3 r1 pc             /* FORM_iRR    0xCB 0x31 0x02 0x00     */
	ezh 3 r1 pc lsb0 r1     /* FORM_iRR    0xCB 0x31 0xA2 0x10     */
#endif

/* 0x40 = GET : Read from the Special Registers space*/
	get d5 r2               /* FORM_RR     0x40 0x62               */
	get d5 r2 bit1 0        /* FORM_RR     0x43 0x62 0x40 0x02     */
	get 2 a4                /* FORM_iR     0x42 0x29               */
	get 2 a4 neq            /* FORM_iR     0x43 0x29 0xE2 0x09     */
	get 240946 a5           /* FORM_IR     0x41 0x73 0x32 0xAD     */

/* 0x04 = HALT : Stop the core*/
	halt                    /* FORM_ALONE  0x04 0x00               */
	halt 7                  /* FORM_i      0x06 0x70               */

/* 0x28 = IB : Insert a byte into a (half)word*/
	ib a1 a3 pc             /* FORM_RRR    0x2B 0xFB 0x00 0x00     */
	ib a1 a3 pc eq          /* FORM_RRR    0x2B 0xFB 0xC0 0x00     */
	ib 3 d3 r1              /* FORM_iRR    0x2B 0x3A 0x02 0x01     */
	ib 3 d3 r1 eq           /* FORM_iRR    0x2B 0x3A 0xC2 0x01     */

#if defined(ARCH_yasep32)
/* 0xA8 = IH : Insert the second operand's Half-word into destination*/
	ih a4 r3 r4             /* FORM_RRR    0xAB 0x93 0x00 0x04     */
	ih a4 r3 r4 msb1 a1     /* FORM_RRR    0xAB 0x93 0xC0 0xF4     */
	ih 2 a1 r5              /* FORM_iRR    0xAB 0x2F 0x02 0x05     */
	ih 2 a1 r5 lsb0 a1      /* FORM_iRR    0xAB 0x2F 0xA2 0xF5     */
#endif

/* 0x80 = IN : Read data from I/O on data bus*/
	in r5 r2                /* FORM_RR     0x80 0x52               */
	in r5 r2 zero a4        /* FORM_RR     0x83 0x52 0x00 0x92     */
	in a4 2                 /* FORM_Ri     0x82 0x29               */
	in a4 2 neq             /* FORM_Ri     0x83 0x29 0xE2 0x00     */
	in d4 28596             /* FORM_RI     0x81 0x08 0xB4 0x6F     */

/* 0xFC = INV : Forbidden (invalid) opcode*/
	inv                     /* FORM_ALONE  0xFC 0x00               */

/* 0x24 = IPC : InterProcess Call*/
	ipc d2 r3               /* FORM_RR     0x24 0xC3               */
	ipc r4 4                /* FORM_Ri     0x26 0x44               */
	ipc r3 22965            /* FORM_RI     0x25 0x03 0xB5 0x59     */

/* 0x44 = IPE : InterProcess Entry*/
	ipe r4 a1               /* FORM_RR     0x44 0x4F               */
	ipe r2 6                /* FORM_Ri     0x46 0x62               */
	ipe r3 14362            /* FORM_RI     0x45 0x03 0x1A 0x38     */

/* 0x64 = IPR : InterProcess Return*/
	ipr r2 r5               /* FORM_RR     0x64 0x25               */
	ipr r4 2                /* FORM_Ri     0x66 0x24               */
	ipr a1 20710            /* FORM_RI     0x65 0x0F 0xE6 0x50     */

/* 0x78 = LUT8 : XOR source register with LookUp Table's contents (1 byte in, 2 or 4 bytes out)*/
	lut8 a2 d1              /* FORM_RR     0x78 0xDE               */
	lut8 a2 d1 no_carry     /* FORM_RR     0x7B 0xDE 0xA0 0x0E     */
	lut8 3 d5               /* FORM_iR     0x7A 0x36               */
	lut8 3 d5 lsb1 d2       /* FORM_iR     0x7B 0x36 0x82 0xC6     */
	lut8 202 a5 r4          /* FORM_IRR    0x79 0x47 0xCA 0x00     */
	lut8 92 r4              /* FORM_IR     0x79 0x44 0x5C 0x00     */
	lut8 r1 d2 r2           /* FORM_RRR    0x7B 0x1C 0x00 0x02     */
	lut8 r1 d2 r2 bit0 6    /* FORM_RRR    0x7B 0x1C 0x60 0x62     */
	lut8 6 d4 d3            /* FORM_iRR    0x7B 0x68 0x02 0x0A     */
	lut8 6 d4 d3 msb1 a2    /* FORM_iRR    0x7B 0x68 0xC2 0xDA     */

/* 0x08 = MOV : Write imm16/imm20/si4 to dest*/
	mov r5 r2               /* FORM_RR     0x08 0x52               */
	mov r5 r2 lsb0 r3       /* FORM_RR     0x0B 0x52 0xA0 0x32     */
	mov 3 d3                /* FORM_iR     0x0A 0x3A               */
	mov 3 d3 lsb1 r1        /* FORM_iR     0x0B 0x3A 0x82 0x1A     */
	mov 198568 r3           /* FORM_IR     0x09 0x33 0xA8 0x07     */

#if defined(ARCH_yasep32)
/* 0x88 = MOVH : Shift operand (R/i4/i16) left by 16 bits*/
	movh d3 a1              /* FORM_RR     0x88 0xAF               */
	movh d3 a1 bit1 4       /* FORM_RR     0x8B 0xAF 0x40 0x4F     */
	movh 5 r5               /* FORM_iR     0x8A 0x55               */
	movh 5 r5 zero a2       /* FORM_iR     0x8B 0x55 0x02 0xD5     */
	movh 17435 a5 d2        /* FORM_IRR    0x89 0xC7 0x1B 0x44     */
	movh 31913 a5           /* FORM_IR     0x89 0x77 0xA9 0x7C     */
	movh d1 a1 r2           /* FORM_RRR    0x8B 0xEF 0x00 0x02     */
	movh d1 a1 r2 bit1 13   /* FORM_RRR    0x8B 0xEF 0x40 0xD2     */
	movh 1 a5 r1            /* FORM_iRR    0x8B 0x17 0x02 0x01     */
	movh 1 a5 r1 msb1 a5    /* FORM_iRR    0x8B 0x17 0xC2 0x71     */
#endif

#if defined(ARCH_yasep32)
/* 0xB8 = MUL16H : Multiply higher halfword (unsigned)*/
	mul16h r3 pc            /* FORM_RR     0xB8 0x30               */
	mul16h r3 pc msb1 d1    /* FORM_RR     0xBB 0x30 0xC0 0xE0     */
	mul16h 1 pc             /* FORM_iR     0xBA 0x10               */
	mul16h 1 pc carry       /* FORM_iR     0xBB 0x10 0x82 0x00     */
	mul16h 31718 d2 r2      /* FORM_IRR    0xB9 0x2C 0xE6 0x7B     */
	mul16h 10198 r3         /* FORM_IR     0xB9 0x33 0xD6 0x27     */
	mul16h a5 d5 r4         /* FORM_RRR    0xBB 0x76 0x00 0x04     */
	mul16h a5 d5 r4 no_carry/* FORM_RRR    0xBB 0x76 0xA0 0x04     */
	mul16h 5 a4 d3          /* FORM_iRR    0xBB 0x59 0x02 0x0A     */
	mul16h 5 a4 d3 eq       /* FORM_iRR    0xBB 0x59 0xC2 0x0A     */
#endif

#if defined(ARCH_yasep32)
/* 0x98 = MUL16L : Multiply lower halfword (unsigned)*/
	mul16l a2 d3            /* FORM_RR     0x98 0xDA               */
	mul16l a2 d3 carry      /* FORM_RR     0x9B 0xDA 0x80 0x0A     */
	mul16l 7 d3             /* FORM_iR     0x9A 0x7A               */
	mul16l 7 d3 carry       /* FORM_iR     0x9B 0x7A 0x82 0x0A     */
	mul16l 30140 pc d3      /* FORM_IRR    0x99 0xA0 0xBC 0x75     */
	mul16l 15178 d1         /* FORM_IR     0x99 0xEE 0x4A 0x3B     */
	mul16l d3 a3 d5         /* FORM_RRR    0x9B 0xAB 0x00 0x06     */
	mul16l d3 a3 d5 bit1 2  /* FORM_RRR    0x9B 0xAB 0x40 0x26     */
	mul16l 5 d2 d3          /* FORM_iRR    0x9B 0x5C 0x02 0x0A     */
	mul16l 5 d2 d3 bit1 4   /* FORM_iRR    0x9B 0x5C 0x42 0x4A     */
#endif

/* 0x38 = MUL8H : Multiply higher byte (unsigned)*/
	mul8h r3 r1             /* FORM_RR     0x38 0x31               */
	mul8h r3 r1 eq          /* FORM_RR     0x3B 0x31 0xC0 0x01     */
	mul8h 7 r5              /* FORM_iR     0x3A 0x75               */
	mul8h 7 r5 bit0 0       /* FORM_iR     0x3B 0x75 0x62 0x05     */
	mul8h 216 a1 a2         /* FORM_IRR    0x39 0xDF 0xD8 0x00     */
	mul8h 229 a4            /* FORM_IR     0x39 0x99 0xE5 0x00     */
	mul8h a4 d1 a1          /* FORM_RRR    0x3B 0x9E 0x00 0x0F     */
	mul8h a4 d1 a1 nz d5    /* FORM_RRR    0x3B 0x9E 0x20 0x6F     */
	mul8h 5 r1 a2           /* FORM_iRR    0x3B 0x51 0x02 0x0D     */
	mul8h 5 r1 a2 neq       /* FORM_iRR    0x3B 0x51 0xE2 0x0D     */

/* 0x18 = MUL8L : Multiply lower byte (unsigned)*/
	mul8l a1 r2             /* FORM_RR     0x18 0xF2               */
	mul8l a1 r2 carry       /* FORM_RR     0x1B 0xF2 0x80 0x02     */
	mul8l 2 a3              /* FORM_iR     0x1A 0x2B               */
	mul8l 2 a3 zero r3      /* FORM_iR     0x1B 0x2B 0x02 0x3B     */
	mul8l 77 d2 pc          /* FORM_IRR    0x19 0x0C 0x4D 0x00     */
	mul8l 194 d1            /* FORM_IR     0x19 0xEE 0xC2 0x00     */
	mul8l r5 d1 d3          /* FORM_RRR    0x1B 0x5E 0x00 0x0A     */
	mul8l r5 d1 d3 carry    /* FORM_RRR    0x1B 0x5E 0x80 0x0A     */
	mul8l 5 d2 r4           /* FORM_iRR    0x1B 0x5C 0x02 0x04     */
	mul8l 5 d2 r4 no_carry  /* FORM_iRR    0x1B 0x5C 0xA2 0x04     */

/* 0x58 = MULI : Initialize one multiply LUT entry*/
	muli r1 r5              /* FORM_RR     0x58 0x15               */
	muli 4 a1               /* FORM_iR     0x5A 0x4F               */
	muli 7337 a4            /* FORM_IR     0x59 0x09 0xA9 0x1C     */

/* 0x50 = NAND : Boolean AND with negated output*/
	nand a5 d3              /* FORM_RR     0x50 0x7A               */
	nand a5 d3 msb1 r1      /* FORM_RR     0x53 0x7A 0xC0 0x1A     */
	nand 1 d2               /* FORM_iR     0x52 0x1C               */
	nand 1 d2 zero d4       /* FORM_iR     0x53 0x1C 0x02 0x8C     */
	nand 13211 r3 d1        /* FORM_IRR    0x51 0xE3 0x9B 0x33     */
	nand 24670 r5           /* FORM_IR     0x51 0x55 0x5E 0x60     */
	nand r3 d2 r5           /* FORM_RRR    0x53 0x3C 0x00 0x05     */
	nand r3 d2 r5 no_carry  /* FORM_RRR    0x53 0x3C 0xA0 0x05     */
	nand 6 r5 r3            /* FORM_iRR    0x53 0x65 0x02 0x03     */
	nand 6 r5 r3 no_carry   /* FORM_iRR    0x53 0x65 0xA2 0x03     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x34 = NEG (alias to SUB) : arithmetic negation*/
	neg d2                  /* FORM_R      0x36 0x0C               */
	neg d2 msb0 r4          /* FORM_R      0x37 0x0C 0xE2 0x4C     */
	neg r3 d5               /* FORM_RR     0x37 0x03 0x02 0x06     */
	neg r3 d5 zero a2       /* FORM_RR     0x37 0x03 0x02 0xD6     */
#endif

/* 0x00 = NOP : Do nothing*/
	nop                     /* FORM_ALONE  0x00 0x00               */

/* 0xB0 = NOR : Boolean OR with negated output*/
	nor a4 r5               /* FORM_RR     0xB0 0x95               */
	nor a4 r5 eq            /* FORM_RR     0xB3 0x95 0xC0 0x05     */
	nor 6 a4                /* FORM_iR     0xB2 0x69               */
	nor 6 a4 eq             /* FORM_iR     0xB3 0x69 0xC2 0x09     */
	nor 22776 a1 d4         /* FORM_IRR    0xB1 0x8F 0xF8 0x58     */
	nor 4591 d4             /* FORM_IR     0xB1 0x88 0xEF 0x11     */
	nor d2 a3 d5            /* FORM_RRR    0xB3 0xCB 0x00 0x06     */
	nor d2 a3 d5 carry      /* FORM_RRR    0xB3 0xCB 0x80 0x06     */
	nor 1 r2 d1             /* FORM_iRR    0xB3 0x12 0x02 0x0E     */
	nor 1 r2 d1 eq          /* FORM_iRR    0xB3 0x12 0xC2 0x0E     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x90 = NOT (alias to ORN) : Boolean negation (alias to ORN)*/
	not r1                  /* FORM_R      0x92 0x01               */
	not r1 nz r2            /* FORM_R      0x93 0x01 0x22 0x21     */
	not pc r1               /* FORM_RR     0x93 0x00 0x02 0x01     */
	not pc r1 nz r1         /* FORM_RR     0x93 0x00 0x22 0x11     */
#endif

/* 0x70 = OR : Boolean OR*/
	or a3 r5                /* FORM_RR     0x70 0xB5               */
	or a3 r5 no_carry       /* FORM_RR     0x73 0xB5 0xA0 0x05     */
	or 7 r3                 /* FORM_iR     0x72 0x73               */
	or 7 r3 no_carry        /* FORM_iR     0x73 0x73 0xA2 0x03     */
	or 16861 d1 r4          /* FORM_IRR    0x71 0x4E 0xDD 0x41     */
	or 27024 a2             /* FORM_IR     0x71 0xDD 0x90 0x69     */
	or r2 a4 a3             /* FORM_RRR    0x73 0x29 0x00 0x0B     */
	or r2 a4 a3 msb1 d3     /* FORM_RRR    0x73 0x29 0xC0 0xAB     */
	or 6 a1 r4              /* FORM_iRR    0x73 0x6F 0x02 0x04     */
	or 6 a1 r4 bit0 10      /* FORM_iRR    0x73 0x6F 0x62 0xA4     */

/* 0x90 = ORN : Boolean OR with one negated input*/
	orn a2 a1               /* FORM_RR     0x90 0xDF               */
	orn a2 a1 zero d2       /* FORM_RR     0x93 0xDF 0x00 0xCF     */
	orn 7 a3                /* FORM_iR     0x92 0x7B               */
	orn 7 a3 msb1 a4        /* FORM_iR     0x93 0x7B 0xC2 0x9B     */
	orn 28816 a4 pc         /* FORM_IRR    0x91 0x09 0x90 0x70     */
	orn 6331 d2             /* FORM_IR     0x91 0xCC 0xBB 0x18     */
	orn a3 d4 pc            /* FORM_RRR    0x93 0xB8 0x00 0x00     */
	orn a3 d4 pc msb0 d3    /* FORM_RRR    0x93 0xB8 0xE0 0xA0     */
	orn 5 r1 r5             /* FORM_iRR    0x93 0x51 0x02 0x05     */
	orn 5 r1 r5 bit0 10     /* FORM_iRR    0x93 0x51 0x62 0xA5     */

/* 0xA0 = OUT : Send data to I/O on the address bus*/
	out pc r1               /* FORM_RR     0xA0 0x01               */
	out r1 2                /* FORM_Ri     0xA2 0x21               */
	out pc 12723            /* FORM_RI     0xA1 0x00 0xB3 0x31     */

/* 0x60 = PUT : Write to the Special Registers space*/
	put r1 d2               /* FORM_RR     0x60 0x1C               */
	put r2 6                /* FORM_Ri     0x62 0x62               */
	put r4 9931             /* FORM_RI     0x61 0x04 0xCB 0x26     */

/* 0x8C = ROL : ROtate Left*/
	rol a4 r3               /* FORM_RR     0x8C 0x93               */
	rol a4 r3 msb1 a5       /* FORM_RR     0x8F 0x93 0xC0 0x73     */
	rol 1 a4                /* FORM_iR     0x8E 0x19               */
	rol 1 a4 bit1 14        /* FORM_iR     0x8F 0x19 0x42 0xE9     */
	rol 22 r4 r1            /* FORM_IRR    0x8D 0x14 0x16 0x00     */
	rol 28 a3               /* FORM_IR     0x8D 0xBB 0x1C 0x00     */
	rol r5 a3 d5            /* FORM_RRR    0x8F 0x5B 0x00 0x06     */
	rol r5 a3 d5 no_carry   /* FORM_RRR    0x8F 0x5B 0xA0 0x06     */
	rol 1 r3 a3             /* FORM_iRR    0x8F 0x13 0x02 0x0B     */
	rol 1 r3 a3 bit0 10     /* FORM_iRR    0x8F 0x13 0x62 0xAB     */

/* 0x6C = ROR : ROtate Right*/
	ror d2 r1               /* FORM_RR     0x6C 0xC1               */
	ror d2 r1 zero a4       /* FORM_RR     0x6F 0xC1 0x00 0x91     */
	ror 2 d2                /* FORM_iR     0x6E 0x2C               */
	ror 2 d2 lsb0 r4        /* FORM_iR     0x6F 0x2C 0xA2 0x4C     */
	ror 30 r2 d4            /* FORM_IRR    0x6D 0x82 0x1E 0x00     */
	ror 20 r2               /* FORM_IR     0x6D 0x22 0x14 0x00     */
	ror d2 r4 a3            /* FORM_RRR    0x6F 0xC4 0x00 0x0B     */
	ror d2 r4 a3 bit0 0     /* FORM_RRR    0x6F 0xC4 0x60 0x0B     */
	ror 3 a3 d2             /* FORM_iRR    0x6F 0x3B 0x02 0x0C     */
	ror 3 a3 d2 bit1 2      /* FORM_iRR    0x6F 0x3B 0x42 0x2C     */

/* 0x2C = SAR : Shift Arithmetic Right*/
	sar r3 r1               /* FORM_RR     0x2C 0x31               */
	sar r3 r1 lsb1 r4       /* FORM_RR     0x2F 0x31 0x80 0x41     */
	sar 3 d3                /* FORM_iR     0x2E 0x3A               */
	sar 3 d3 no_carry       /* FORM_iR     0x2F 0x3A 0xA2 0x0A     */
	sar 16 d3 d2            /* FORM_IRR    0x2D 0xCA 0x10 0x00     */
	sar 26 r2               /* FORM_IR     0x2D 0x22 0x1A 0x00     */
	sar pc a1 d2            /* FORM_RRR    0x2F 0x0F 0x00 0x0C     */
	sar pc a1 d2 never      /* FORM_RRR    0x2F 0x0F 0x20 0x0C     */
	sar 3 a2 d2             /* FORM_iRR    0x2F 0x3D 0x02 0x0C     */
	sar 3 a2 d2 carry       /* FORM_iRR    0x2F 0x3D 0x82 0x0C     */

/* 0x4C = SHL : SHift logic Left*/
	shl r4 r5               /* FORM_RR     0x4C 0x45               */
	shl r4 r5 bit1 14       /* FORM_RR     0x4F 0x45 0x40 0xE5     */
	shl 7 a4                /* FORM_iR     0x4E 0x79               */
	shl 7 a4 zero a2        /* FORM_iR     0x4F 0x79 0x02 0xD9     */
	shl 29 a1 d4            /* FORM_IRR    0x4D 0x8F 0x1D 0x00     */
	shl 22 r2               /* FORM_IR     0x4D 0x22 0x16 0x00     */
	shl d3 a3 a2            /* FORM_RRR    0x4F 0xAB 0x00 0x0D     */
	shl d3 a3 a2 zero a1    /* FORM_RRR    0x4F 0xAB 0x00 0xFD     */
	shl 7 r1 d4             /* FORM_iRR    0x4F 0x71 0x02 0x08     */
	shl 7 r1 d4 never       /* FORM_iRR    0x4F 0x71 0x22 0x08     */

/* 0x0C = SHR : SHift logic Right*/
	shr a1 r1               /* FORM_RR     0x0C 0xF1               */
	shr a1 r1 lsb0 r5       /* FORM_RR     0x0F 0xF1 0xA0 0x51     */
	shr 1 a5                /* FORM_iR     0x0E 0x17               */
	shr 1 a5 never          /* FORM_iR     0x0F 0x17 0x22 0x07     */
	shr 23 r1 a3            /* FORM_IRR    0x0D 0xB1 0x17 0x00     */
	shr 20 r5               /* FORM_IR     0x0D 0x55 0x14 0x00     */
	shr a1 d4 a2            /* FORM_RRR    0x0F 0xF8 0x00 0x0D     */
	shr a1 d4 a2 msb0 d1    /* FORM_RRR    0x0F 0xF8 0xE0 0xED     */
	shr 6 r3 r5             /* FORM_iRR    0x0F 0x63 0x02 0x05     */
	shr 6 r3 r5 no_carry    /* FORM_iRR    0x0F 0x63 0xA2 0x05     */

/* 0xF4 = SMAX : Set dest to imm16/si4 if snd's value is greater (signed) than imm16/si4*/
	smax r5 a1              /* FORM_RR     0xF4 0x5F               */
	smax r5 a1 msb1 a3      /* FORM_RR     0xF7 0x5F 0xC0 0xBF     */
	smax 1 d2               /* FORM_iR     0xF6 0x1C               */
	smax 1 d2 never         /* FORM_iR     0xF7 0x1C 0x22 0x0C     */
	smax 21941 a1 a3        /* FORM_IRR    0xF5 0xBF 0xB5 0x55     */
	smax 7035 a3            /* FORM_IR     0xF5 0xBB 0x7B 0x1B     */
	smax d3 a2 a3           /* FORM_RRR    0xF7 0xAD 0x00 0x0B     */
	smax d3 a2 a3 bit0 8    /* FORM_RRR    0xF7 0xAD 0x60 0x8B     */
	smax 4 a3 d5            /* FORM_iRR    0xF7 0x4B 0x02 0x06     */
	smax 4 a3 d5 never      /* FORM_iRR    0xF7 0x4B 0x22 0x06     */

/* 0xD4 = SMIN : Set dest to imm16/si4 if snd's value is less (signed) than imm16/si4*/
	smin a5 a3              /* FORM_RR     0xD4 0x7B               */
	smin a5 a3 bit0 7       /* FORM_RR     0xD7 0x7B 0x60 0x7B     */
	smin 6 r2               /* FORM_iR     0xD6 0x62               */
	smin 6 r2 msb1 a2       /* FORM_iR     0xD7 0x62 0xC2 0xD2     */
	smin 14088 a5 d2        /* FORM_IRR    0xD5 0xC7 0x08 0x37     */
	smin 22786 a5           /* FORM_IR     0xD5 0x77 0x02 0x59     */
	smin d2 r4 r3           /* FORM_RRR    0xD7 0xC4 0x00 0x03     */
	smin d2 r4 r3 never     /* FORM_RRR    0xD7 0xC4 0x20 0x03     */
	smin 2 a3 a4            /* FORM_iRR    0xD7 0x2B 0x02 0x09     */
	smin 2 a3 a4 lsb1 r4    /* FORM_iRR    0xD7 0x2B 0x82 0x49     */

/* 0x34 = SUB : Substraction*/
	sub a1 a3               /* FORM_RR     0x34 0xFB               */
	sub a1 a3 lsb0 a5       /* FORM_RR     0x37 0xFB 0xA0 0x7B     */
	sub 4 a4                /* FORM_iR     0x36 0x49               */
	sub 4 a4 bit1 13        /* FORM_iR     0x37 0x49 0x42 0xD9     */
	sub 16987 d2 r1         /* FORM_IRR    0x35 0x1C 0x5B 0x42     */
	sub 8048 a5             /* FORM_IR     0x35 0x77 0x70 0x1F     */
	sub d3 d5 pc            /* FORM_RRR    0x37 0xA6 0x00 0x00     */
	sub d3 d5 pc msb0 a2    /* FORM_RRR    0x37 0xA6 0xE0 0xD0     */
	sub 1 r4 a5             /* FORM_iRR    0x37 0x14 0x02 0x07     */
	sub 1 r4 a5 zero d5     /* FORM_iRR    0x37 0x14 0x02 0x67     */

/* 0xB4 = UMAX : Set dest to imm16/si4 if snd's value is greater (unsigned) than imm16/si4*/
	umax pc r3              /* FORM_RR     0xB4 0x03               */
	umax pc r3 never        /* FORM_RR     0xB7 0x03 0x20 0x03     */
	umax 3 a3               /* FORM_iR     0xB6 0x3B               */
	umax 3 a3 lsb1 d5       /* FORM_iR     0xB7 0x3B 0x82 0x6B     */
	umax 14240 d5 a1        /* FORM_IRR    0xB5 0xF6 0xA0 0x37     */
	umax 30773 r5           /* FORM_IR     0xB5 0x55 0x35 0x78     */
	umax r5 d2 d3           /* FORM_RRR    0xB7 0x5C 0x00 0x0A     */
	umax r5 d2 d3 msb1 a3   /* FORM_RRR    0xB7 0x5C 0xC0 0xBA     */
	umax 3 r2 a4            /* FORM_iRR    0xB7 0x32 0x02 0x09     */
	umax 3 r2 a4 nz d2      /* FORM_iRR    0xB7 0x32 0x22 0xC9     */

/* 0x94 = UMIN : Set dest to imm16/si4 if snd's value is less (unsigned) than imm16/si4*/
	umin r5 r4              /* FORM_RR     0x94 0x54               */
	umin r5 r4 carry        /* FORM_RR     0x97 0x54 0x80 0x04     */
	umin 2 d1               /* FORM_iR     0x96 0x2E               */
	umin 2 d1 no_carry      /* FORM_iR     0x97 0x2E 0xA2 0x0E     */
	umin 17427 r5 r3        /* FORM_IRR    0x95 0x35 0x13 0x44     */
	umin 7210 a4            /* FORM_IR     0x95 0x99 0x2A 0x1C     */
	umin r1 a2 a1           /* FORM_RRR    0x97 0x1D 0x00 0x0F     */
	umin r1 a2 a1 zero d4   /* FORM_RRR    0x97 0x1D 0x00 0x8F     */
	umin 6 d4 r2            /* FORM_iRR    0x97 0x68 0x02 0x02     */
	umin 6 d4 r2 bit1 4     /* FORM_iRR    0x97 0x68 0x42 0x42     */

/* 0xD0 = XOR : Boolean XOR*/
	xor r2 d5               /* FORM_RR     0xD0 0x26               */
	xor r2 d5 neq           /* FORM_RR     0xD3 0x26 0xE0 0x06     */
	xor 6 d3                /* FORM_iR     0xD2 0x6A               */
	xor 6 d3 neq            /* FORM_iR     0xD3 0x6A 0xE2 0x0A     */
	xor 15150 a2 a4         /* FORM_IRR    0xD1 0x9D 0x2E 0x3B     */
	xor 30174 d2            /* FORM_IR     0xD1 0xCC 0xDE 0x75     */
	xor d3 a1 d1            /* FORM_RRR    0xD3 0xAF 0x00 0x0E     */
	xor d3 a1 d1 msb1 a1    /* FORM_RRR    0xD3 0xAF 0xC0 0xFE     */
	xor 5 a4 r4             /* FORM_iRR    0xD3 0x59 0x02 0x04     */
	xor 5 a4 r4 eq          /* FORM_iRR    0xD3 0x59 0xC2 0x04     */

/* 0xF0 = XORN : Boolean XOR with negated output*/
	xorn a5 r1              /* FORM_RR     0xF0 0x71               */
	xorn a5 r1 msb1 a5      /* FORM_RR     0xF3 0x71 0xC0 0x71     */
	xorn 7 r1               /* FORM_iR     0xF2 0x71               */
	xorn 7 r1 lsb0 d4       /* FORM_iR     0xF3 0x71 0xA2 0x81     */
	xorn 10518 r4 d5        /* FORM_IRR    0xF1 0x64 0x16 0x29     */
	xorn 16517 a4           /* FORM_IR     0xF1 0x99 0x85 0x40     */
	xorn d3 r3 r1           /* FORM_RRR    0xF3 0xA3 0x00 0x01     */
	xorn d3 r3 r1 zero a5   /* FORM_RRR    0xF3 0xA3 0x00 0x71     */
	xorn 5 a5 d3            /* FORM_iRR    0xF3 0x57 0x02 0x0A     */
	xorn 5 a5 d3 carry      /* FORM_iRR    0xF3 0x57 0x82 0x0A     */

