/* yasep/lang.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 20110909 by whygee@f-cpu.org
20110912 : objectified
20111122 : body_start() can change the default language
20120513 : moved the pictures as divs in logos/logos.css
20120912 : moved init_obj() to  gui-js/menu.js, added LS, LT, I8N() and window.onerror, LANG.LANG becomes LNG
Some definitions and general utilities for managing the languages.

LNG is also read/written by yasep/cookies.js
*/

LANG={
  supported:false,
  LN:"", // the selected language string, can be different from browsLang

// inline images to save some HTTP requests
  FLAGS:[], // initialised by init_obj

  change_innerHTML: [], // beware of memory leaks !
//  change_title: [],

  change_lang: function(i){
    i=+i; // in the case where the argument is a string

    var j,k;
    if ((i<0)||(i>=i8n.LANGS.length))
      i=0;

    LANG.LN=i8n.LANGS[
              LNG=i];
    cookies.save();

    document.title="YASEP: "+I8N("welc").replace(/&nbsp;/gi," ");

    for (j in LANG.change_innerHTML){
//      k=LANG.change_innerHTML[j];
      if (k=LANG.change_innerHTML[j]) {
        if(typeof k[1][i] == "string")
          k[0].innerHTML=k[1][i];
        else
          if(typeof k[1][0] == "string")
            k[0].innerHTML=k[1][0];
      }
    }
/*
    for (j in LANG.change_title){
      k=LANG.change_title[j];
      if (k) {
        if(typeof k[1][i] == "string")
          k[0].title=k[1][i];
        else
          if(typeof k[1][0] == "string")
            k[0].title=k[1][0];
      }
    }
*/
  }
};

// detect the browser's language : 20120829
browsLang=(navigator.language||navigator.browserLanguage).slice(0,2);

// LNG may be changed later when reading the cookies, it
// could become any large integer number, as it gets encoded/decoded in base66.
LNG=i8n.LANGS.indexOf(browsLang);
if (LNG<0)
  LNG=0;
else
  LANG.supported=true;


// 20120830 : IDEA!!!! :-)
// 20120914: will be removed, superseded by i8n
function LT(t) {
  return t[LNG] || t[0]
}
function LS() {
  return arguments[LNG] || arguments[0]
}
function Alrt(){
  alert (arguments[LNG] || arguments[0])
}
function AlrT(t){
  alert (t[LNG] || t[0])
}

function I8N(i,t){ // dirty variable generation syntax... t is not a parameter...
  t=i8n[i];
  if (!t)
    return i; // alert("lang.js: unknown message "+i);
  if (t[LNG])
    return t[LNG];
//  if (t[0])
    return t[0] || i;
//  return i;
} // Note : I8N can return an array of strings. Or anything else in an array stored in i8n.js !


// Get a variable length argument,
// interpret "" as followed by a litteral argument,
// otherwise use an internationalised string :
function Al8N(){
  var i=0,s="",t,a,l=LNG;
  while (typeof(a=arguments[i++])!="undefined"){
    if (a=="")
      s+=arguments[i++];
    else
      s+=I8N(a);
  }
  alert(s)
}

function generated(c,tool){
  return "\n"+c+" "+I8N("Generated on")+" "+new Date().toGMTString() +"\n"
             +c+" "+I8N("by")+" "+document.location+"\n"
             +c+"    yasep/"+tool+" "+I8N("version")+" "+VERSION+"\n";
}

function setHTML(o,t){
  if (typeof t == "string")
    o.innerHTML=t;
  else {
    // suppose it's an array (because the contents is not optional
    if (t.length > 1)
      LANG.change_innerHTML.push([o,t]);
    o.innerHTML=t[LNG] || t[0];
  }
}
/*
function setTitle(o,t){
  if (typeof t == "string")
    o.title=t;
  else {
    if (typeof t == "object") {
      o.title=t[LNG] || t[0];
      LANG.change_title.push([o,t]);
    }
    else
      o.title=" "; // null title will not modify the default, but space will not appear (hopefully)
         // it appears on webkit browsers :-( (opera, chrome, safari, ...)
  }
}

window.onerror=function(msg, url, l){
 alert(I8N("Ierr1")+msg
      +I8N("Ierr2")+l
      +I8N("Ierr3"));
 return false
}

window.onbeforeunload=function(){
  if (somethingtosave)
    return confirm("You're about to leave,\nare you sure you want\nto discard unsaved works ?");
}
*/
